/*
	PROforma, PROgs FOnt & Raster MAnager

	CopyArea function, to copy a part of the bitmap

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 24 January 1996
*/

#include "PFmodule.h"

#define BUFFER_SIZE 200

static Error tobuff(unsigned char *to, unsigned char *from,
					short xsiz, short xorg)
{
	int lshift, rshift;

	from+=xorg/8*2;
	lshift=xorg&7;
	rshift=8-lshift;

	*to=*from<<lshift;
	for (xsiz-=rshift ; xsiz>0 ; xsiz-=8)
	{
		from+=2;
		*to++|=*from>>rshift;
		*to   =*from<<lshift;
	}
	return ERR_OK;
}

static Error frombuff(unsigned char *from, unsigned char *to,
					short xsiz, short xorg)
{
	int lshift, rshift;
	unsigned int lmask, rmask;
	int xend=xorg+xsiz;

	to+=xorg/8*2;
	rshift=xorg&7;
	lshift=8-rshift;
	rmask=0xff>>(xend&7);
	lmask=0xff<<lshift;

	if (xsiz<lshift)
	{
		*to=(*to&(lmask|rmask))|((*from>>rshift)&~(lmask|rmask));
	}
	else
	{
		*to=(*to&lmask)|*from>>rshift;
		for (xsiz-=lshift ; xsiz>=8 ; xsiz-=8)
		{
			to+=2;
			*to =(*from++)<<lshift;
			*to|= *from   >>rshift;
		}
		to+=2;
		*to =(*to&rmask)|(((*from++)<<lshift)&~rmask)
						|(( *from	>>rshift)&~rmask);
	}
	return ERR_OK;
}

Error CopyArea(Bitmap from, Bitmap to, short xsiz, short ysiz,
			   short fromx, short fromy, short tox, short toy)
{
	unsigned char buffer[BUFFER_SIZE];
	unsigned char *obuff, *dbuff;
	int i, currxsiz;
	int oinc=from->linc;
	int dinc=  to->linc;

	if (fromy<toy)
	{
		fromy+=ysiz-1;
		toy+=ysiz-1;
		oinc=-oinc;
		dinc=-dinc;
	}

	while (xsiz)
	{
		obuff=from->base+fromy*from->linc;
		dbuff=	to->base+  toy*  to->linc;
		currxsiz=xsiz>BUFFER_SIZE*8 ? BUFFER_SIZE*8 : xsiz;

		for (i=ysiz ; i ; i--)
		{
			  tobuff(buffer,obuff,currxsiz,fromx);
			frombuff(buffer,dbuff,currxsiz,tox);
			  tobuff(buffer,obuff+1,currxsiz,fromx);
			frombuff(buffer,dbuff+1,currxsiz,tox);
			obuff+=oinc;
			dbuff+=dinc;
		}

		xsiz-=currxsiz;
		fromx+=currxsiz;
		tox+=currxsiz;
	}
	return ERR_OK;
}
